#ifdef TETRIS_ARM_SUPPORT

#define TYPE_EXTERNAL(FunctionName) t_ ## FunctionName
#define PTR_EXTERNAL(FunctionName) p_ ## FunctionName
#define DEFINE_EXTERNAL(FunctionName) \
	t_ ## FunctionName p_ ## FunctionName

#define BODY_EXTERNAL(FunctionName, LoadName, Library) \
	if (p_ ## FunctionName == NULL) \
	{ \
		HMODULE hModule = LoadLibrary(_T( #Library ) ); \
		if (hModule != NULL) \
		{ \
			p_ ## FunctionName = (t_ ## FunctionName)GetProcAddress(hModule, #LoadName ); \
		} \
	} \
	NULL

/////////////////////
// timeBeginPeriod
/////////////////////
typedef WINMMAPI MMRESULT (WINAPI *TYPE_EXTERNAL(timeBeginPeriod))( _In_ UINT uPeriod);
extern DEFINE_EXTERNAL(timeBeginPeriod);

/////////////////////
// timeEndPeriod
/////////////////////
typedef WINMMAPI MMRESULT (WINAPI *TYPE_EXTERNAL(timeEndPeriod))( _In_ UINT uPeriod);
extern DEFINE_EXTERNAL(timeEndPeriod);

/////////////////////
// CreateSolidBrush
/////////////////////
typedef WINGDIAPI HBRUSH (WINAPI *TYPE_EXTERNAL(CreateSolidBrush))(_In_ COLORREF color);
extern DEFINE_EXTERNAL(CreateSolidBrush);

/////////////////////
// CreatePen
/////////////////////
typedef WINGDIAPI HPEN (WINAPI *TYPE_EXTERNAL(CreatePen))( _In_ int iStyle, _In_ int cWidth, _In_ COLORREF color);
extern DEFINE_EXTERNAL(CreatePen);

/////////////////////
// DeleteObject
/////////////////////
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(DeleteObject))( _In_ HGDIOBJ ho);
extern DEFINE_EXTERNAL(DeleteObject);

/////////////////////
//SelectObject
/////////////////////
typedef WINGDIAPI HGDIOBJ (WINAPI *TYPE_EXTERNAL(SelectObject))(_In_ HDC hdc, _In_ HGDIOBJ h);
extern DEFINE_EXTERNAL(SelectObject);

//////////////////////
// SetPixel
//////////////////////
typedef WINGDIAPI COLORREF (WINAPI *TYPE_EXTERNAL(SetPixel))(_In_ HDC hdc, _In_ int x, _In_ int y, _In_ COLORREF color);
extern DEFINE_EXTERNAL(SetPixel);

///////////////////////
// MoveToEx
///////////////////////
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(MoveToEx))( _In_ HDC hdc, _In_ int x, _In_ int y, _Out_opt_ LPPOINT lppt);
extern DEFINE_EXTERNAL(MoveToEx);

///////////////////////
// LineTo
///////////////////////
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(LineTo))( _In_ HDC hdc, _In_ int x, _In_ int y);
extern DEFINE_EXTERNAL(LineTo);

///////////////////////
// TextOut
///////////////////////
#undef TextOut
#ifdef UNICODE
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(TextOut))( _In_ HDC hdc, _In_ int x, _In_ int y, _In_reads_(c) LPCWSTR lpString, _In_ int c);
#else
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(TextOut))( _In_ HDC hdc, _In_ int x, _In_ int y, _In_reads_(c) LPCSTR lpString, _In_ int c);
#endif
extern DEFINE_EXTERNAL(TextOut);

///////////////////////
// GetDeviceCaps
///////////////////////
typedef WINGDIAPI int (WINAPI *TYPE_EXTERNAL(GetDeviceCaps))( _In_opt_ HDC hdc, _In_ int index);
extern DEFINE_EXTERNAL(GetDeviceCaps);

///////////////////////
// CreateFont
///////////////////////
#undef CreateFont
#ifdef UNICODE
typedef WINGDIAPI HFONT (WINAPI *TYPE_EXTERNAL(CreateFont))(
	_In_ int cHeight, _In_ int cWidth, _In_ int cEscapement, _In_ int cOrientation, _In_ int cWeight, _In_ DWORD bItalic,
	_In_ DWORD bUnderline, _In_ DWORD bStrikeOut, _In_ DWORD iCharSet, _In_ DWORD iOutPrecision, _In_ DWORD iClipPrecision,
	_In_ DWORD iQuality, _In_ DWORD iPitchAndFamily, _In_opt_ LPCWSTR pszFaceName);
#else
typedef WINGDIAPI HFONT (WINAPI *TYPE_EXTERNAL(CreateFont))(
	_In_ int cHeight, _In_ int cWidth, _In_ int cEscapement, _In_ int cOrientation, _In_ int cWeight, _In_ DWORD bItalic,
	_In_ DWORD bUnderline, _In_ DWORD bStrikeOut, _In_ DWORD iCharSet, _In_ DWORD iOutPrecision, _In_ DWORD iClipPrecision,
	_In_ DWORD iQuality, _In_ DWORD iPitchAndFamily, _In_opt_ LPCSTR pszFaceName);
#endif
extern DEFINE_EXTERNAL(CreateFont);

// from here on...
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(DeleteDC))( _In_ HDC hdc);
extern DEFINE_EXTERNAL(DeleteDC);
typedef WINGDIAPI HDC (WINAPI *TYPE_EXTERNAL(CreateCompatibleDC))( _In_opt_ HDC hdc);
extern DEFINE_EXTERNAL(CreateCompatibleDC);
typedef WINGDIAPI HBITMAP (WINAPI *TYPE_EXTERNAL(CreateCompatibleBitmap))( _In_ HDC hdc, _In_ int cx, _In_ int cy);
extern DEFINE_EXTERNAL(CreateCompatibleBitmap);
typedef WINGDIAPI COLORREF (WINAPI *TYPE_EXTERNAL(SetTextColor))(_In_ HDC hdc, _In_ COLORREF color);
extern DEFINE_EXTERNAL(SetTextColor);
typedef WINGDIAPI int (WINAPI *TYPE_EXTERNAL(SetBkMode))(_In_ HDC hdc, _In_ int mode);
extern DEFINE_EXTERNAL(SetBkMode);
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(BitBlt))( _In_ HDC hdc, _In_ int x, _In_ int y, _In_ int cx, _In_ int cy, _In_opt_ HDC hdcSrc, _In_ int x1, _In_ int y1, _In_ DWORD rop);
extern DEFINE_EXTERNAL(BitBlt);
typedef WINGDIAPI int (WINAPI *TYPE_EXTERNAL(SetStretchBltMode))(_In_ HDC hdc, _In_ int mode);
extern DEFINE_EXTERNAL(SetStretchBltMode);
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(SetBrushOrgEx))( _In_ HDC hdc, _In_ int x, _In_ int y, _Out_opt_ LPPOINT lppt);
extern DEFINE_EXTERNAL(SetBrushOrgEx);
typedef WINGDIAPI int (WINAPI *TYPE_EXTERNAL(SetDIBits))(_In_opt_ HDC hdc, _In_ HBITMAP hbm, _In_ UINT start, _In_ UINT cLines, _In_ CONST VOID *lpBits, _In_ CONST BITMAPINFO * lpbmi, _In_ UINT ColorUse);
extern DEFINE_EXTERNAL(SetDIBits);
typedef WINGDIAPI BOOL (WINAPI *TYPE_EXTERNAL(StretchBlt))(_In_ HDC hdcDest, _In_ int xDest, _In_ int yDest, _In_ int wDest, _In_ int hDest, _In_opt_ HDC hdcSrc, _In_ int xSrc, _In_ int ySrc, _In_ int wSrc, _In_ int hSrc, _In_ DWORD rop);
extern DEFINE_EXTERNAL(StretchBlt);

extern void ArmInitializeAll();

#else

#define PTR_EXTERNAL(X) (X)

//#define ArmInitializeAll() (NULL)

#endif
