// Gradient.cpp: implementation of the Gradient class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Gradient.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Gradient::Gradient()
{
}

void Gradient::Init()
{
	ZeroMemory(&m_bitmapInfo, sizeof (BITMAPINFO));
	m_bitmapInfo.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
	m_bitmapInfo.bmiHeader.biWidth = PIC_SIZE_X;
	m_bitmapInfo.bmiHeader.biHeight = PIC_SIZE_Y;
	m_bitmapInfo.bmiHeader.biPlanes = 1;
	m_bitmapInfo.bmiHeader.biBitCount = 32;
	m_bitmapInfo.bmiHeader.biCompression = BI_RGB;

	m_change.InitPoints();
	m_change.Init();

	ReInit();
	Fill();
}

void Gradient::ReInit()
{
	int i;

	for (i = 0; i < GradientChange::INITIAL_POINTS; i++)
	{
		m_stars[i].Advance();
	}
}

void Gradient::Fill()
{
	double dist;
	double r, g, b;
	int x, y, i;
	int index;
	COLORREF color;

	index = 0;
	for (y = 0; y < I_HEIGHT; ++y)
	{
		for (x = 0; x < I_WIDTH; ++x)
		{
			r = 0; g = 0; b = 0;
			for (i = 0; i < GradientChange::INITIAL_POINTS; i++)
			{
				dist = m_change.m_distances[x][y][i];
				color = m_stars[i].GetColor();
				r += GetRValue(color) * dist;
				g += GetGValue(color) * dist;
				b += GetBValue(color) * dist;
			}
			m_bits[index++] = RGB(
				MathRound<DWORD>(r),
				MathRound<DWORD>(g),
				MathRound<DWORD>(b)
			);
		}
	}
}
