#include "stdafx.h"
#include "MovementStage.h"

MovementStage::MovementStage(int maxStageBase):
	m_stage(0),
	m_maxStage(0),
	m_maxStageBase(maxStageBase),
	m_escalation(0)
{
}

void MovementStage::Advance()
{
	if (m_stage > 0)
	{
		--m_stage;
	}
	if (m_stage < 1)
	{
		Cancel();
	}
}

void MovementStage::Escalate()
{
	++m_escalation;
	if (m_stage < 1)
	{
		m_stage = m_maxStageBase;
		m_maxStage = m_maxStageBase;
	}
	else
	{
		const int addition = MathRound<int>(
			float(m_maxStageBase) /
			float(m_escalation));
		m_stage += addition;
		m_maxStage += addition;
	}
}

int MovementStage::GetValue(int base)
{
	const float movementShare = float(m_stage) / float(m_maxStage);
	return MathRound<int>(movementShare * base) * m_escalation;
}

void MovementStage::Cancel()
{
	m_stage = 0;
	m_maxStage = 0;
	m_escalation = 0;
}
