#include "stdafx.h"
#include "Mutex.h"

Mutex::Mutex()
{
	InitializeCriticalSection(&m_criticalSection);
}
Mutex::~Mutex()
{
	DeleteCriticalSection(&m_criticalSection);
}

void Mutex::Enter()
{
	::EnterCriticalSection(&m_criticalSection);
}

void Mutex::Leave()
{
	::LeaveCriticalSection(&m_criticalSection);
}

Synchronized::Synchronized(Mutex & mutex) : m_mutex(mutex)
{
	m_mutex.Enter();
}

Synchronized::~Synchronized()
{
	m_mutex.Leave();
}
