// Piece.h: interface for the Piece class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "RotatedArray3D.h"
#include "Array2D.h"
#include "Square.h"

class Piece
{
public:

	enum
	{
		MAX_PIECES = 4 * 4 * 4
	};

	Piece(COLORREF color, int a, int b, int c, int * data);
	~Piece();

	void GetColors(Array2D * arr);
	void GetColors(int index, Array2D * arr);
	int GetCols();
	int GetRows();
	int GetCols(int index);
	int GetRows(int index);
	void Rotate();
	void Unrotate();
	void Restore();
	int GetIndex();

	// public data:

	COLORREF color;
	COLORREF pale;
	COLORREF dark;

	HBRUSH colorBrush;

	HPEN palePen;
	HPEN darkPen;

private:
	RotatedArray3D allColorModes;

	int index;
	int prev;

	Square * squaresPtr[MAX_PIECES];
	Square squares[MAX_PIECES];

};
