// RotatedArray3D.cpp: implementation of the RotatedArray3D class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RotatedArray3D.h"
#include "Square.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RotatedArray3D::RotatedArray3D(int a, int b, int c, Square ** data)
{
	this->a = a;
	this->b = b;
	this->c = c;
	this->data = data;
}

Square * RotatedArray3D::Get(int x, int y, int z)
{
	int virtualB, virtualC;
	if ((x % 2) != 0)
	{
		virtualB = this->c;
		virtualC = this->b;
	}
	else
	{
		virtualB = this->b;
		virtualC = this->c;
	}
	return this->data[(virtualB * virtualC * x) + (virtualC * y) + z];
}

int RotatedArray3D::GetLength()
{
	return a;
}

int RotatedArray3D::GetLength(int x)
{
	if ((x % 2) != 0)
	{
		return this->c;
	}
	return this->b;
}

int RotatedArray3D::GetLength(int x, int y)
{
	(void)y;
	if ((x % 2) != 0)
	{
		return this->b;
	}
	return this->c;
}
