// Square.h: interface for the Square class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

class Piece;

class Square
{
public:

	enum
	{
		NIL = -1,

		LEFT = 1,
		RIGHT = 2,
		UP = 4,
		DOWN = 8,

		L = LEFT,
		R = RIGHT,
		U = UP,
		D = DOWN,

		BEG = 5
	};

	Square();

	void Set(int orientation, Piece * piece);

	void PaintRectangle(
		int x,
		int y,
		int width,
		int height
	);

private:
	int orientation;
	Piece * piece;

	bool Is(int dir);
	void DrawLine(
		int dir,
		int x1, int y1, int x2, int y2,
		bool vert
	);

};
