// Stage.cpp: implementation of the Stage class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Stage.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Stage::Stage(int max)
{
	Randomize();

	this->max = max;
	this->value =
		((int)(MathRandom() * 1000 * max)) % max;
	this->direction = MathRandom() >= 0.5;
}

void Stage::Advance()
{
	if (direction)
	{
		++value;
		if (value >= max)
		{
			value = max;
			direction = false;
		}
	}
	else
	{
		--value;
		if (value <= -1)
		{
			value = 0;
			direction = true;
		}
	}
}

int Stage::GetValue()
{
	return this->value;
}
