// Star.h: interface for the Star class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "Stage.h"
#include "StarColors.h"
class Stage;
class StarColors;

class Star
{
public:
	enum
	{
		COLOR_MIN = 32,

		NUMBER_OF_STAGES = 71,
		SECOND_STAGE = 50
	};

	Star();
	COLORREF GetColor();
	void Paint();
	void RemoveNext();
	void Advance();

	static COLORREF RandColorLight();

	static Star * GetStar(int maxX, int maxY, Star * next);
	static Star * PutStar(Star * s);

	int iy;
	int x;
	float yd;
	float speed;

	Star * next;

	Stage colorStage;
	Stage brightnessStage;

private:

	StarColors colors[NUMBER_OF_STAGES];

};
