// StarField.cpp: implementation of the StarField class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "StarField.h"
#include "Star.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

StarField::StarField()
{
	this->head = NULL;
	this->count = 2;
}

void StarField::Create(LPPOINT size)
{
	count++;
	if (count == 3)
	{
		count = 0;
		if (MathRandom() >= 0.7)
		{
			head = Star::GetStar(size->x - 1, size->y - 1, head);
		}
	}
}

void StarField::Move()
{
	Star * star = head;
	if (star != NULL)
	{
		star->Advance();
		if (star->iy < -2)
		{
			star = head = Star::PutStar(star);
		}
		if (star != NULL)
		{
			for (Star * s = head; s->next != NULL;)
			{
				star = s->next;
				star->Advance();
				if (star->iy < -2)
				{
					s->RemoveNext();
					star = s->next;
					if (star != NULL)
					{
						s = star;
					}
				}
				else
				{
					s = star;
				}
			}
		}
	}
}

void StarField::Paint()
{
	for (Star * s = head; s != NULL; s = s->next)
	{
		s->Paint();
	}
}
